﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using dhtmlxConnectors;
using System.Configuration;

/// <summary>
/// Connector body
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class schedulerConnector : dhtmlxRequestHandler
{
    public override IdhtmlxConnector CreateConnector(HttpContext context)
    {
        dhtmlxSchedulerConnector connector = new dhtmlxSchedulerConnector(
            @"Select EventId, UserId, JobId, SE.SchedulerTypeId, FromDate, ToDate, EventName, EventDescription, " +
                  @"IsBillable, IsTentative, ApprovedUserId, ApprovedDate, CreatedUserId, CreatedDate, UpdatedUserId, " +
                  @"UpdatedDate, SchedulerType, IsJob, SchedulerColour FROM SchedulerEvents SE JOIN SchedulerTypes ST ON SE.SchedulerTypeId = ST.SchedulerTypeId"
            , "EventId"
            , dhtmlxDatabaseAdapterType.SqlServer2005
            , "Data Source=SERVER;Initial Catalog=Scheduler;User Id=USER;Password=PASSWORD;integrated security=False"
            , "FromDate"
            , "ToDate"
            , "FromDate as FromDate, ToDate as ToDate, EventName as text, EventId as EventId, UserId as UserId, JobId as JobId, SE.SchedulerTypeId as SchedulerTypeId," +
                " EventDescription as EventDescription, IsBillable as IsBillable, IsTentative as IsTentative, ApprovedUserId as ApprovedUserId, ApprovedDate as ApprovedDate," +
                " CreatedUserId as CreatedUserId, CreatedDate as CreatedDate, UpdatedUserId as UpdatedUserId, UpdatedDate as UpdatedDate, SchedulerType as SchedulerType," +
                " IsJob as IsJob, SchedulerColour as SchedulerColour"
        );

        connector.Request.CustomSQLs.Add(CustomSQLType.Delete, @"DELETE FROM [SchedulerEvents] WHERE EventId = {EventId}");

        connector.Request.CustomSQLs.Add(CustomSQLType.Update, @"UPDATE [SchedulerEvents] " +
          @" SET [UserId] = {UserId}," +
          @"     [JobId] = {JobId}," +
          @"     [SchedulerTypeId] = {SchedulerTypeId}," +
          @"     [FromDate] = '{FromDate}'," +
          @"     [ToDate] = '{ToDate}'," +
          @"     [EventName] = '{text}'," +
          @"     [EventDescription] = '{EventDescription}'," +
          @"     [IsBillable] = {IsBillable}," +
          @"     [IsTentative] = {IsTentative}," +
          @"     [UpdatedUserId] = 32," +
          @"     [UpdatedDate] = '" + DateTime.Now.ToString("yyyy-MM-dd HH:mm") + "'" +
          @"         WHERE EventId = {EventId}");

        connector.Request.CustomSQLs.Add(CustomSQLType.Insert, @"INSERT INTO [SchedulerEvents] " +
       @"([UserId]," +
       @" [JobId]," +
       @" [SchedulerTypeId]," +
       @" [FromDate]," +
       @" [ToDate]," +
       @" [EventName]," +
       @" [EventDescription]," +
       @" [IsBillable]," +
       @" [IsTentative]," +
       @" [CreatedUserId]," +
       @" [CreatedDate])" +
       @"   VALUES" +
       @"    ({UserId}," +
       @"    {JobId}," +
       @"    {SchedulerTypeId}," +
       @"    '{FromDate}'," +
       @"    '{ToDate}'," +
       @"    '{text}'," +
       @"    '{EventDescription}'," +
       @"    {IsBillable}," +
       @"    {IsTentative}," +
       @"    32," +
       @"    '" + DateTime.Now.ToString("yyyy-MM-dd HH:mm") + "')");

        return connector;
    }

}
